#include "align.h"   /* special constants for align programs */
#include <stdio.h>

/* externals from slurp */
 extern int fetchline();
 extern void writeline();
 extern int linecount();
 extern char nextchar();
 extern char peekchar();
 extern int open_source();
 extern FILE *outstream;

/* externals from glosses */
extern int sepv;
extern char sepc;
extern int msepv;
extern char msepc;
extern int wsepv;
extern char wsepc;
extern int modev;
extern int widthv;
extern int indentv;
extern char delmark;
extern char amark;
extern char umark;
extern void glosses();
extern void skip();

/* local parameters */
int closev = TRUE;
int example = FALSE;
int excount = 0;

/* error stuff */
int sinned   = FALSE;  /* error has occurred in run */
int error = FALSE;  /* error has occurred in current example */

void goof(s)
char *s;
{
  fprintf(stderr,"%s\n",s);
  error = TRUE;
}


void modify()
{
  while (modify2())
    if (advanceeoln() && nextchar() == ',') {}
}

int streq(c,d)
char *c,*d;
{
  return(!strcmp(c,d));
}

#define if_command(c,d) if (streq(com,c)) d = v;
#define if_width(c,d,e) if (streq(com,c)) {d = v; e = val[0];}
#define if_charcode(c,d) if (streq(com,c)) d = val[0];


int modify2()
{
  char com[20];
  char val[5];
  int v;

  if (gettoken(com)) {
    if (gettoken(val)) {
      v = atoi(val);
      if_command("mode",modev)
      else
      if_command("width",widthv)
      else
      if_command("indent",indentv)
      else
      if_width("sep",sepv,sepc)
      else
      if_width("msep",msepv,msepc)
      else
      if_width("wsep",wsepv,wsepc)
      else
      if_charcode("delmark",delmark)
      else
      if_charcode("amark",amark)
      else
      if_charcode("umark",umark)
      else
      if (streq(com,"comwidths"))
	get_com_widths(val);
      return(TRUE);
    }
  }
  return(FALSE);
}




main()

{


  char c;

  get_com_widths("widths.dat");
  open_source("text.dat");


  while (fetchline()) {
    if ((c = nextchar()) == delmark) { /* process glossed example */
      if (example) fputs("@break()",outstream);
      glosses();
      example = TRUE;
    }
    else                     /* process something else */
    if (c == '.') {
      if ((c = nextchar()) == '!') {   /* such as parameter modification */
	modify();
      }
    }
    else {
      example = FALSE;
      writeline();
    }
  }
}

