/* in this module appeaars machinery connected with the recognition
   storage of words */

#include "align.h"     /* align definitions */
/* VAX/VMS version
#include <unixio>
*/
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <math.h>


/* externals from errors.c */
extern goof(); /* error-writing routine
  void goof(char *s); */
extern int sinned, error; /* error-flags */

/* externals from slurp.c */
extern nextchar(); /* gets next character
  char nextchar(); */
extern peekchar(); /* peeks at next char
  char peekchar() */
extern advance();  /* advances to next printing char
  void advance(); */

/* externals from glosses */
extern char delmark;     /* example delimiter */
extern int wordmax;      /* maximum length of word */

/* word storage */

static char store[charmax];  /* array for storing string */
static char *free_char;      /* pointer to first available position */
static char *top_char;       /* pointer to top of store */

/* initializes store */
init_store()
{
  free_char = store;
  top_char = store+charmax;
}

/* stows characters */
int stow(c)
char c;
{
  if (free_char<top_char) {
    *(free_char++) = c;
    return(TRUE);
  }
  else {
    goof("too many characters in example");
  }
}


static int envpointer; /* keeps track of group nesting */


void readword(here, stop, quit, grab, lookahead)
word *here;      /* location of word record to be filled in */
int *stop;       /* where to record whether stop-delimiter encountered */
int (*quit)();          /* function specifying whether to stop */
char (*grab)();  /* character-reading procedure to be used */
int lookahead;   /* whether to advance to next printing char */
{

  char c;                 /* character holder */

  *stop = FALSE;
  envpointer = 0;

  here->loc=free_char;
  c=grab();
  while (envpointer > 0 || !quit(c)) {  /* there is nothing
      in the stack, or neither of the word-enders encountered */
    stow(c);
    if (error) return;
    else
    if (c == '\\') {
      if (peekchar() == ' ') {
	grab(c);
	stow(c);
      }
    }
    else
    if (c == '{')
      envpointer++;
    if (envpointer > 0 && c == '}')
      envpointer--;
    c=grab();
    if (c == delmark && envpointer > 0) {
      goof("line-break within TeX command");
      envpointer = 0;
    }
  }

  stow('\0'); /* mark end of word i store */
  if (c == delmark) *stop = TRUE;
  if (!*stop) {
    if (lookahead) {
      advance();
      if (peekchar()==delmark) {
	*stop = TRUE;
	nextchar();
      }
    }
  }
}

/* readword hacked for the peculiar demands of the `columns'
module, essentially being that length calculations are done so
that alignments can be worked out on the screen */

void readword_col(here, bar, quit, grab)
word *here;      /* location of word record to be filled in */
int *bar;       /* where to record whether bar-delimiter encountered */
int (*quit)();          /* function specifying whether to stop */
char (*grab)();  /* character-reading procedure to be used */
{

  char c;                 /* character holder */
  int size;
  char com[20];           /* command-holder */

  *bar = FALSE;
  envpointer = 0;

  here->loc=free_char;
  size=0;
  c=grab();
  while (envpointer > 0 || !quit(c)) {  /* there is nothing
      in the stack, or neither of the word-enders encountered */
    stow(c);
    if (error) return;
    else
    if (c == '\\') {
      if (peekchar() == ' ') {
	grab(c);
	stow(c);
      }
    }
    else
    if (c == '{')
      envpointer++;
    if (envpointer > 0 && c == '}')
      envpointer--;
    size++;
    c=grab();
    if (c == delmark && envpointer > 0) {
      goof("line-break within TeX command");
      envpointer = 0;
    }
  }
  stow('\0'); /* mark end of word i store */
  here->size = size;
  if (c == '|') *bar = TRUE;

}

/* writes words to a stream */
void writeword(out,it)
FILE *out;
word *it;
{
  fprintf(out,"{%s}",it->loc);
}

/*
char delmark = '\\';
int  wordmax = 60;

main()
{
word sample;
int stop;

get_com_widths("widths.dat");
open_source("text.dat");
init_store();


advance();
readword(&sample,&stop,' ',nextchar,0);
printf("%s, size = %d, bracket= %d\n",sample.loc,sample.size,sample.bracket);
if (stop) printf("stop!\n");

}

*/

